/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2010 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 *  Copyright (C) 2010 by Meika Sugimoto
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */
#include <setjmp.h>

#include <stddef.h>
#include <limits.h>


#include "kernel_impl.h"
#include "task.h"

#include "kernel_cfg.h"


/*
 *  g[XO}ÑftHg`
 */

#ifndef LOG_DSP_ENTER
	#define LOG_DSP_ENTER(tskidx)
#endif /* LOG_DSP_ENTER */

#ifndef LOG_DSP_LEAVE
	#define LOG_DSP_LEAVE(tskidx)
#endif /* LOG_DSP_ENTER */


extern const intptr_t	tinib_exinf[];			/* ^XN̊g */
extern const TASK    	tinib_task[];			/* ^XN̋NԒn */
extern const uint_t  	tinib_epriority[];		/* ^XN̎sDxxi\j */



#define TOPPERS_tskini

#ifdef TOPPERS_tskini

/*-------------------------------------------
 * fBXpb`[̃ReLXg
 */
jmp_buf disp_ctx;		//fBXpb`ReLXg


/*
 * sԃ^XN̋NDx
 */
uint_t runtsk_ipri;

/*
 *  fBL[T[`̂߂̃rbg}bv
 */
volatile uint_t	ready_primap;

/*
 *  ^XNfBXpb`NvtO
 */
bool_t	reqflg;

/*
 *  fBXpb`֎~
 */
bool_t	disdsp;


/* 
 * O@stask
 */
intptr_t last_ipri;

/*
 *  read_primap̏l
 */
extern const uint_t init_rdypmap;

#endif /* TOPPERS_tskini */

#define TOPPERS_get_ipri_self
#ifdef TOPPERS_get_ipri_self

/*
 *  ^XNIDNDxo߂̃}N
 */
uint_t
get_ipri_self(ID tskid)
{
	uint_t inipri;
	
	if(tskid != TSK_SELF)
	{
		inipri = (uint_t)((tskid) - TMIN_TSKID);
	}
	else
	{
		inipri = runtsk_ipri;
	}
	return inipri;
}

#endif /* TOPPERS_get_ipri_self */

#define TOPPERS_get_ipri
#ifdef TOPPERS_get_ipri

uint_t
get_ipri(ID tskid)
{
	return (uint_t)(tskid - TMIN_TSKID);
}

#endif /* TOPPERS_get_ipri */

/*
 *  rbg}bvT[`֐
 *
 *  bitmap1̃rbg̓CłʁiEĵ̂T[`C̃rb
 *  gԍԂDrbgԍ́Cŉʃrbg0ƂDbitmap0w
 *  Ă͂ȂȂD̊֐ł́Cbitmap8rbgł邱Ƃ肵C
 *  uint8_t^ƂĂD
 *
 *  rbgT[`߂vZbTł́CrbgT[`߂g悤
 *  ǂꍇD̂悤ȏꍇɂ́C^[Qbg
 *  ˑŃrbgT[`߂gbitmap_search`C
 *  OMIT_BITMAP_SEARCH}N`΂悢D܂CrbgT[`߂
 *  T[`tȂǂ̗RŗDxƃrbgƂ̑ΉύXꍇ
 *  ́CPRIMAP_BIT}N`΂悢D
 *
 *  ܂CWCuffsȂĈ悤ɒ`ĕWCu
 *  gǂ\D
 *		#define	bitmap_search(bitmap) (ffs(bitmap) - 1)
 */
#ifndef PRIMAP_BIT
#define	PRIMAP_BIT(pri)		(1U << (pri))
#endif /* PRIMAP_BIT */


#ifndef OMIT_BITMAP_SEARCH




/*
 *  ݔ񐔂ۑϐ
 */
uint16_t	intnest;


static const uint8_t bitmap_search_table[] = { 0U, 1U, 0U, 2U, 0U, 1U, 0U,
												3U, 0U, 1U, 0U, 2U, 0U, 1U, 0U };



#pragma inline (bitmap_search)
static  uint_t bitmap_search(uint_t bitmap)
{
	uint_t	n = 0U;

	if ((bitmap & 0x0fU) == 0U) {
		bitmap >>= 4U;
		n += 4U;
	}
	return (n + bitmap_search_table[(bitmap & 0x0fU) - 1U]);
}

#endif /* OMIT_BITMAP_SEARCH */

/*
 *  Dxrbg}bv󂩂̃`FbN
 */
#pragma inline (primap_empty) 
static bool_t primap_empty(void)
{
	return (ready_primap == 0U);
}

/*
 *  w肵Dx̗Dxrbg}bvZbgĂ邩ǂ̃`FbN
 */
#pragma inline (primap_test) 
static bool_t primap_test(uint_t pri)
{
	return ((ready_primap & PRIMAP_BIT(pri)) != 0U);
}

/*
 *  Dxrbg}bṽT[`
 */
#pragma inline (primap_search) 
static uint_t primap_search(void)
{
	return bitmap_search((uint_t)ready_primap);
}

/*
 *  Dxrbg}bṽZbg
 */
#pragma inline (primap_set) 
static void primap_set(uint_t pri)
{
	ready_primap |= PRIMAP_BIT(pri);
}

/*
 *  Dxrbg}bṽNA
 */
#pragma inline (primap_clear) 
static void primap_clear(uint_t pri)
{
	ready_primap &= ~PRIMAP_BIT(pri);
}

/*
 *  ōD揇ʃ^XÑT[`
 */
#define TOPPERS_tsksched

#ifdef TOPPERS_tsksched

uint_t
search_schedtsk(void)
{
	return primap_search();
}

#endif /* TOPPERS_tsksched */

/*
 * w肵NDx̃^XNsłԂǂ̃eXg
 *
 * słꍇtrueԂD
 */
bool_t
test_dormant(uint_t ipri)
{
	return !primap_test(ipri);
}

/*
 *  ^XNǗW[̏
 */

#define TOPPERS_tskini

#ifdef TOPPERS_tskini


/*----------------------------------------------------------
 *	ԂÑ^XNɂ
 *  make_active()Ń^XNreadyԂɂ		takahashi
 */
void
initialize_task(void)
{
	intptr_t ipri;
	/* fBL[̃rbg}bv */
	ready_primap = init_rdypmap;
	
	/* sDx̏ */
	runtsk_ipri = IPRI_NULL;

	last_ipri = 0xff;		//肦Ȃlɂ
	
	/* ^XNReLXg̐ݒ*/
	for(ipri = 0;ipri <  TNUM_TSKID;ipri++)
	{
		if (primap_test(ipri))
		{
			make_ctx(ipri);
		}
		task_wait[ipri] = 0;
	}
	
	/* ݋֎~tȌ */
	disdsp = false;
}

#endif /* TOPPERS_tskini */

/*-----------------------------------------------------
 *  ReLXg̏Ă					takahashi
 */
static jmp_buf jmpp;		//̃[`̃Z[up
 
void make_ctx(uint_t ipri)
{
	t_lock_cpu();
//	printf("make_ctx ipri= %d\n",ipri);
	if (setjmp(jmpp) == 0)	//ɖ߂p
	{
		//
		// ^XNX^bNɐ؂ւ
		set_task_stack(TOPPERS_TASKSTKPT(ipri ));
		if (setjmp(task_ctx[ipri]) == 0)
		{
			/*o^ꍇ*/
			longjmp(jmpp,1);	//߂
		}
		else
		{
			/* ^XNN */
			t_unlock_cpu();
			/* ^XNɗ܂*/
			/* ^XNsJn */
			(*((TASK)(tinib_task[ipri])))(tinib_exinf[ipri]);
			disdsp = false;
			/* rbg}bvNAD */
			primap_clear(ipri);
			
			//^XNIꍇǂ̂H--> ̂Ƃ́@dispacher()ɍs
			longjmp(disp_ctx,1);			//sta_keȓɍs
		}
	}
	else
	{
		//o^I
		t_unlock_cpu();
	}
}


/*
 *  ipri : NΏۃ^XN̋NDx(\)
 */
#define TOPPERS_tskact 
#ifdef TOPPERS_tskact

bool_t
make_active(uint_t ipri)
{
	bool_t dsp;
	
	primap_set(ipri);
	
	if(ipri < runtsk_ipri) {
		dsp = !disdsp;
	}
	else {
		dsp = false;
	}
	
	make_ctx(ipri);
	
	return dsp;
}

#endif /* TOPPERS_tskact */


/*
 *  apri : sJn^XN̋NDx
 *  ĂяoF CPUbN
 *  ̃[`͔p~				takahashi
 */


#ifdef TOPPERS_tskrun

void
run_task(uint_t ipri)
{
}
#endif /* TOPPERS_tskrun */

/*
 *  ̊֐͑S݃bNԂƓ̏Ԃ sta_ker Ă΂
 *	̃[`͔p~悤Ǝvdispacĥ݂̂܂								takahashi
 */

#define TOPPERS_tsk_dsp
#ifdef TOPPERS_tsk_dsp
void dispatch(intptr_t ipri)
{
	last_ipri = ipri;
;	runtsk_ipri = ipri;
	longjmp(task_ctx[ipri],1);
}

void
dispatcher(void)
{
	do {
		if(!primap_empty()) {
			/* ^XN̊Jn */
			//run_task(search_schedtsk());
			dispatch(search_schedtsk());		//ꂩ͋AĂȂ
		}
		else {
			idle_loop();
		}
	} while(true);
}

ER
wai_tsk(void)
{
	ER		ercd;
	uint_t	tskpri;
	
//	LOG_ACT_TSK_ENTER(tskid);
//	CHECK_TSKCTX_UNL();
//	CHECK_TSKID_SELF(tskid);
	
	tskpri = get_ipri_self(TSK_SELF);
	//tskpri = runtsk_ipri;
	t_lock_cpu();
	task_wait[tskpri] = 1;		//wait
	primap_clear(tskpri);		//fBQ폜
	
	//̃ReLNXgo^
	if (setjmp(task_ctx[tskpri]) == 0)
	{
		/*o^ꍇ*/
		longjmp(disp_ctx,1);			//sta_keȓɍs
	}
	else
	{
		// ^XNAꍇ
		t_unlock_cpu();
		return(ercd);
	}	

	t_unlock_cpu();

  error_exit:

	return(ercd);
}

ER
go_tsk(ID tskid)
{
	ER		ercd;
	uint_t	self_tskpri;	//Ăяo^XN
	uint_t	ipri;			//go ^XN
	
	
//	LOG_ACT_TSK_ENTER(tskid);
//	CHECK_TSKCTX_UNL();
//	CHECK_TSKID_SELF(tskid);
	
	ipri = get_ipri(tskid);
	self_tskpri = get_ipri_self(TSK_SELF);	
	t_lock_cpu();
	if (task_wait[ipri] == 0)
	{
		t_unlock_cpu();
		return(E_OBJ);
	}

	task_wait[ipri] = 0;		//waitԉ
	primap_set(ipri);		//fBQǉ
	


	//̃ReLNXgo^
	if (setjmp(task_ctx[self_tskpri]) == 0)
	{
		/*o^ꍇ*/
		longjmp(disp_ctx,1);			//sta_keȓɍs
	}
	else
	{
		// ^XNAꍇ
		t_unlock_cpu();
		return(ercd);
	}	

	t_unlock_cpu();

  error_exit:

	return(ercd);
}


#endif /* TOPPERS_tsk_dsp */
